> For the complete documentation index, see [llms.txt](https://docs.pyck.cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pyck.cloud/graphql-api/services/maindata.md).

# maindata

Audience: Programmer

## Queries

* [customers](https://docs.pyck.cloud/graphql-api/queries/customers.md)
* [mainDataServiceInfo](https://docs.pyck.cloud/graphql-api/queries/maindataserviceinfo.md)
* [node](https://docs.pyck.cloud/graphql-api/queries/node.md) — Fetches an object given its ID.
* [nodes](https://docs.pyck.cloud/graphql-api/queries/nodes.md) — Lookup nodes by a list of IDs.
* [suppliers](https://docs.pyck.cloud/graphql-api/queries/suppliers.md)

## Mutations

* [createCustomer](https://docs.pyck.cloud/graphql-api/mutations/createcustomer.md)
* [createSupplier](https://docs.pyck.cloud/graphql-api/mutations/createsupplier.md)
* [deleteCustomer](https://docs.pyck.cloud/graphql-api/mutations/deletecustomer.md)
* [deleteSupplier](https://docs.pyck.cloud/graphql-api/mutations/deletesupplier.md)
* [patchCustomerData](https://docs.pyck.cloud/graphql-api/mutations/patchcustomerdata.md) — Apply RFC 6902 JSON Patch operations to the customer's data field.
* [patchSupplierData](https://docs.pyck.cloud/graphql-api/mutations/patchsupplierdata.md) — Apply RFC 6902 JSON Patch operations to the supplier's data field.
* [updateCustomer](https://docs.pyck.cloud/graphql-api/mutations/updatecustomer.md)
* [updateSupplier](https://docs.pyck.cloud/graphql-api/mutations/updatesupplier.md)

## Entities

| Type                                                                      | Key                   |
| ------------------------------------------------------------------------- | --------------------- |
| [Customer](https://docs.pyck.cloud/graphql-api/types/customer.md)         | `id`                  |
| [PickingOrder](https://docs.pyck.cloud/graphql-api/types/pickingorder.md) | `customerID tenantID` |
| [Supplier](https://docs.pyck.cloud/graphql-api/types/supplier.md)         | `id`                  |

## Fields on shared types

| Type                                                                      | Fields                                                                                                             |
| ------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------ |
| [Customer](https://docs.pyck.cloud/graphql-api/types/customer.md)         | `dataTypeID`, `dataTypeSlug`, `data`, `createdAt`, `createdBy`, `updatedAt`, `updatedBy`, `deletedAt`, `deletedBy` |
| [PickingOrder](https://docs.pyck.cloud/graphql-api/types/pickingorder.md) | `customerID`, `customer`                                                                                           |
| [Supplier](https://docs.pyck.cloud/graphql-api/types/supplier.md)         | `dataTypeID`, `dataTypeSlug`, `data`, `createdAt`, `createdBy`, `updatedAt`, `updatedBy`, `deletedAt`, `deletedBy` |

## Types

* [Customer](https://docs.pyck.cloud/graphql-api/types/customer.md)
* [CustomerConnection](https://docs.pyck.cloud/graphql-api/types/customerconnection.md) — A connection to a list of items.
* [CustomerDeletePayload](https://docs.pyck.cloud/graphql-api/types/customerdeletepayload.md)
* [CustomerEdge](https://docs.pyck.cloud/graphql-api/types/customeredge.md) — An edge in a connection.
* [EntityEventsOutbox](https://docs.pyck.cloud/graphql-api/types/entityeventsoutbox.md)
* [PageInfo](https://docs.pyck.cloud/graphql-api/types/pageinfo.md) — Information about pagination in a connection.
* [PickingOrder](https://docs.pyck.cloud/graphql-api/types/pickingorder.md)
* [ServiceInfo](https://docs.pyck.cloud/graphql-api/types/serviceinfo.md)
* [Supplier](https://docs.pyck.cloud/graphql-api/types/supplier.md)
* [SupplierConnection](https://docs.pyck.cloud/graphql-api/types/supplierconnection.md) — A connection to a list of items.
* [SupplierDeletePayload](https://docs.pyck.cloud/graphql-api/types/supplierdeletepayload.md)
* [SupplierEdge](https://docs.pyck.cloud/graphql-api/types/supplieredge.md) — An edge in a connection.

## Interfaces

* [Node](https://docs.pyck.cloud/graphql-api/interfaces/node.md) — An object with an ID.

## Inputs

* [CreateCustomerInput](https://docs.pyck.cloud/graphql-api/inputs/createcustomerinput.md) — CreateCustomerInput is used for create Customer object.
* [CreateSupplierInput](https://docs.pyck.cloud/graphql-api/inputs/createsupplierinput.md) — CreateSupplierInput is used for create Supplier object.
* [CustomerOrder](https://docs.pyck.cloud/graphql-api/inputs/customerorder.md) — Ordering options for Customer connections
* [CustomerWhereInput](https://docs.pyck.cloud/graphql-api/inputs/customerwhereinput.md) — CustomerWhereInput is used for filtering Customer objects.
* [EntityEventsOutboxWhereInput](https://docs.pyck.cloud/graphql-api/inputs/entityeventsoutboxwhereinput.md) — EntityEventsOutboxWhereInput is used for filtering EntityEventsOutbox objects.
* [JSONPatchInput](https://docs.pyck.cloud/graphql-api/inputs/jsonpatchinput.md) — A single RFC 6902 JSON Patch operation.
* [SupplierOrder](https://docs.pyck.cloud/graphql-api/inputs/supplierorder.md) — Ordering options for Supplier connections
* [SupplierWhereInput](https://docs.pyck.cloud/graphql-api/inputs/supplierwhereinput.md) — SupplierWhereInput is used for filtering Supplier objects.
* [UpdateCustomerInput](https://docs.pyck.cloud/graphql-api/inputs/updatecustomerinput.md) — UpdateCustomerInput is used for update Customer object.
* [UpdateSupplierInput](https://docs.pyck.cloud/graphql-api/inputs/updatesupplierinput.md) — UpdateSupplierInput is used for update Supplier object.

## Enums

* [CustomerOrderField](https://docs.pyck.cloud/graphql-api/enums/customerorderfield.md) — Properties by which Customer connections can be ordered.
* [JSONPatchOp](https://docs.pyck.cloud/graphql-api/enums/jsonpatchop.md) — RFC 6902 JSON Patch operation type.
* [JSONType](https://docs.pyck.cloud/graphql-api/enums/jsontype.md) — JSON type for casting extracted JSONB values during ordering.
* [OrderDirection](https://docs.pyck.cloud/graphql-api/enums/orderdirection.md) — Possible directions in which to order a list of items when provided an `orderBy` argument.
* [SupplierOrderField](https://docs.pyck.cloud/graphql-api/enums/supplierorderfield.md) — Properties by which Supplier connections can be ordered.

## Scalars

* [Cursor](https://docs.pyck.cloud/graphql-api/scalars/cursor.md) — Define a Relay Cursor type: <https://relay.dev/graphql/connections.htm#sec-Cursor>
* [Map](https://docs.pyck.cloud/graphql-api/scalars/map.md) — The builtin Map type
* [Time](https://docs.pyck.cloud/graphql-api/scalars/time.md) — The builtin Time type
* [UUID](https://docs.pyck.cloud/graphql-api/scalars/uuid.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pyck.cloud/graphql-api/services/maindata.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
